<?php

/* $Id: YmlExport.class.php 2012-09-12 10:22 Rolland $ */

class YmlExport{
    // для json-ответа 
    var $response=array();
    // для json ошибок
    var $errors=array();
    
    var $my_settings = array();
    var $module_data = null;
    
    var $my_settings_keys = array(
        'SHOP_NAME',
        'SHOP_COMPANY',
        'SUBDIVISION_ID',
        'CATEGORIES_FROM',
        'CATEGORIES_LIST',
        'PRICE_FIELD',
        'PICTURE_FIELD',
        'NAME_FIELD',
        'VENDOR_FIELD',
        'DESCRIPTION_FIELD',
        'CATEGORY_FIELD'
    );
    
    public function __construct($my_settings = array()){
        global $nc_core;
        if(!empty($my_settings)){
            foreach($this->my_settings as $key=>$value){
                $this->my_settings[$key] = rtrim($value,'_ ');    
            }
            $this->my_settings = $my_settings;
        }
        $sel_query = "SELECT * FROM `Module` WHERE Keyword = 'yml_export'" ;
        $this->module_data = $nc_core->db->get_row($sel_query);
    }
    # вывод формы настройки
    public function ShowSettings(){
        global $db, $UI_CONFIG, $SUB_FOLDER, $HTTP_ROOT_PATH, $nc_core,$MODULE_FOLDER;
        // вытаскиваем дерево сайта
        $tree = $this->GetFullStructure(0,0,'plain');
        // вытаскиваем список классификаторов
        $classifier_list = $this->getClassificatorsList();
        include($MODULE_FOLDER."yml_export/settings_form.php");    
    }
    
    # функция записи информации в базу
    public function SaveSettings() {
        global $nc_core;
        // перед сохранением надо снести из поста все, что не является полями настроек 
        foreach($_POST as $key=>$value){
            $key = rtrim($key,'_'); // у нетката там могут появиться подчеркивания,если в базе пробелы стоят 
            if(!in_array($key,array('ModuleID')) && !in_array($key,$this->my_settings_keys)){
                unset($_POST[$key]);
            }
        }
        if(empty($_POST['CATEGORIES_FROM']) || !in_array($_POST['CATEGORIES_FROM'],array('list','subdivisions'))){
            $_POST['CATEGORIES_FROM'] = 'list';
        }
        // проверяем параметры
        $this->checkModuleSettings($_POST);    
        $parameters = '';
        foreach($this->my_settings_keys as $key){
            $parameters .=$key.'=';
            if(isset($_POST[$key])){
                $parameters .= trim($_POST[$key]);
            }else{
                $parameters .= (isset($this->my_settings[$key])?$this->my_settings[$key]:'');    
            }
            $parameters.="\n";
        }
        $nc_core->db->last_error = "";
        $upd_query = "UPDATE Module SET Parameters='".$nc_core->db->escape($parameters)."' WHERE Module_ID='".$this->module_data->Module_ID."'";
        $nc_core->db->query($upd_query);
        if(!empty($nc_core->db->last_error)){
            throw new Exception($nc_core->db->last_error);     
        }
        return true;
    }   
    /**
    * получение полного дерева каталоглв сайта
     */
    public function GetFullStructure($section = 0,$level = 0,$mode = 'structured') {
        global $nc_core;
        $sel_query = "SELECT *
                FROM Subdivision 
                WHERE Parent_Sub_ID = $section" ;
        $res  = $nc_core->db->get_results($sel_query);
        if(!empty($res)){
            foreach($res as $key=>$row){
                $row->level = (int)$level;
                if($mode == 'structured'){
                    $res[$key]->children = $this->GetFullStructure($row->Subdivision_ID,$level+1,$mode);
                }elseif($mode == 'plain'){
                    $res = array_merge($res,$this->GetFullStructure($row->Subdivision_ID,$level+1,$mode))  ;
                }
            } 
            return $res; 
        }else{
            return array();
        }
    }
    
    public function getClassificatorsList(){
        global $nc_core;
        $sel_query = "SELECT *
                FROM Classificator" ;
        $res  = $nc_core->db->get_results($sel_query);
        if(!empty($res)){
            return $res;
        }    
        return array();
    }   
    
    // проверяет, возможен ли экспорт данного раздела
    public function checkSubdivisionId($subdivision_ID){
        global $nc_core;
        $sel_query = "SELECT *
                FROM Subdivision
                WHERE Subdivision_ID = $subdivision_ID" ;
        
        $subdivision = $nc_core->db->get_row($sel_query);
        // проверяем ,существует ли раздел
        if(empty($subdivision)){
            return false;
        }
        // все OK
        return $subdivision;    
    }
    // отдает html формы настроек експорта для конкретного подраздела
    public function SubdivisionSettingsForm($subdivision){
        global $MODULE_FOLDER,$nc_core;
        if(is_numeric($subdivision)){
            $subdivision = $this->checkSubdivisionId($subdivision);    
        }
        if(!$subdivision){
            throw new Exception(YML_EXPORT_WRONG_SUBDIVISION);
        }
        if(empty($this->my_settings['CATEGORIES_FROM']) || $this->my_settings['CATEGORIES_FROM'] == 'list'){ 
            // если генерация происходит для подраздела, к которому непосредственно подключен компонент, и категория берется из списка 
            $sub_class = $this->getSubdivisionComponent($subdivision->Subdivision_ID); 
            if(!$sub_class){
                throw new Exception(YML_EXPORT_SUBDIVISION_HAS_NO_COMPONENTS);
            }   
        }else{
            // генерация для подразделов пока не реализована
            throw new Exception('Generation for subdivisions is not ready yet');
        }  
        // выбираем все поля компонента
        $sel_query = "SELECT *
                FROM Field
                WHERE Class_ID  = {$sub_class->Class_ID}" ;
        $fields = $nc_core->db->get_results($sel_query);
        if(empty($fields)){
            throw new Exception(YML_EXPORT_SUBDIVISION_COMPONENT_HAS_NO_FIELDS);    
        }
        ob_start();
        include($MODULE_FOLDER."yml_export/subdivision_settings_form.php");
        $ret = ob_get_contents();
        ob_end_clean() ;
        return $ret;
    }
    // 
    function getSubdivisionComponent($Subdivision_ID){
        global $nc_core;
        // получаем компонент, подключенный в разделе. если несколько - толькко первый 
        $sel_query = "SELECT *
                FROM Sub_Class
                WHERE Subdivision_ID = ".$Subdivision_ID."
                LIMIT 1" ;
        return $nc_core->db->get_row($sel_query);    
    }
    // проверяет на ошибки и выводит ответ либо ошибки
    public function _echo_response(){
        if(empty($this->errors))
        {
            $this->response['success']=true;
        }else{
            $this->_make_errors();
        }
        header('Content-type: application/json');
        echo json_encode($this->response);
        exit();
    }
    // чистит массив ответа и склеивает строку ошибок 
    protected function _make_errors(){
        $this->response=array();
        $this->response['message']='';
        foreach($this->errors as $err){
            $this->response['message'].=$err."\n";
        }
    }
    
    // проверка на существование списка
    protected function checkListExists($list_id){
        global $nc_core;
        $sel_query = "SELECT *
                FROM Classificator
                WHERE Classificator_ID = ".$list_id." LIMIT 1" ;
        return $nc_core->db->get_row($sel_query);    
    }
    // проверяет настройки модуля и выводит YML, если все OK
    function printYML(){
        global $nc_core,$SUB_FOLDER,$MODULE_FOLDER;
        $this->checkModuleSettings($this->my_settings);
        // собираем инфу для экспорта
        // категории
        switch($this->my_settings['CATEGORIES_FROM']){
            case 'list':
                // имя списка
                $classificator = $this->checkListExists($this->my_settings['CATEGORIES_LIST']);
                // сам список
                $sel_query = "
                    SELECT 
                        `".$classificator->Table_Name."_Name` as category_name, 
                        `".$classificator->Table_Name."_ID` as category_ID 
                    FROM `Classificator_".$classificator->Table_Name."` ";
                $categories = $nc_core->db->get_results($sel_query);
            break;
            case 'subdivisions':
            default:
                throw new Exception('Generation for subdivisions is not ready yet');
            
        }
        // данные о сайте 
        $netcat_version = $nc_core->db->get_var("SELECT `Value` from `Settings` WHERE `Key` = 'VersionNumber'");
        // подраздел
        $subdivision = $this->checkSubdivisionId($this->my_settings['SUBDIVISION_ID']);
        // путь до корня сайта вверх от подраздела
        $path_string = $this->getPathString($subdivision);
        // элементы каталога
        $sub_class = $this->getSubdivisionComponent($subdivision->Subdivision_ID);
        $sel_query = "
            SELECT * 
            FROM Message".$sub_class->Class_ID."     
            ";
        $offers = $nc_core->db->get_results($sel_query);
        // название полей,в которов описаны параметры заказа 
        $pictureFieldName = $this->getFieldNameById($this->my_settings['PICTURE_FIELD']);
        $categoryFieldName = $this->getFieldNameById($this->my_settings['CATEGORY_FIELD']);
        
        $vendorFieldName = $this->getFieldNameById($this->my_settings['VENDOR_FIELD']);
        $nameFieldName = $this->getFieldNameById($this->my_settings['NAME_FIELD']);
        $descriptionFieldName = $this->getFieldNameById($this->my_settings['DESCRIPTION_FIELD']);
        // отдаем строку YML
        header('Content-type: application/xml; charset=utf-8');
        include($MODULE_FOLDER."yml_export/yml_page.php"); 
    }
    // проверяет, что переданный массив состоял только из настроек модуля и его элементы имели допустимые значения
    protected function checkModuleSettings($new_settings){
        // если параметров не столько,как надо 
        if(count($new_settings) != count($this->my_settings_keys)){
            echo '<pre>';
            var_dump($new_settings); echo '<br>' ;
            var_dump($this->my_settings_keys); echo '<br>' ;
            echo '</pre>';
            throw new Exception(YML_EXPORT_NOT_ALL_FIELDS_SET);    
        }
        // проверка параметров
        foreach($new_settings as $key=>$value){
            switch($key){
                case 'CATEGORIES_LIST':  // список для вывода категорий 
                    if($new_settings['CATEGORIES_FROM'] == 'list' && (empty($value) || !($this->checkListExists($value))))     
                        throw new Exception(YML_EXPORT_LIST_DOES_NOT_EXISTS);
                    break;
                case 'SUBDIVISION_ID':  // подраздел сайта
                    if(empty($value) || !$this->checkSubdivisionId($value))     
                        throw new Exception(YML_EXPORT_WRONG_SUBDIVISION);
                    break;
                default :
                    // просто не должно быть пустое
                    if(empty($value))
                        throw new Exception(sprintf(YML_EXPORT_PARAMETER_IS_NOT_SET,$key)); 
            }
        }
        return true;    
    }
    // получение структуры разделов от указанного вверх
    protected function getPathTree($subdivision){
        if(is_numeric($subdivision)){
            $subdivision = $this->checkSubdivisionId($subdivision);
        }
        $ret = array($subdivision);  
        while($subdivision->Parent_Sub_ID !=0){
            $subdivision = $this->checkSubdivisionId($subdivision->Parent_Sub_ID);        
            //$ret[] = $subdivision;
            array_unshift($ret,$subdivision) ;
        }  
        return $ret;
    }
    // путь до подраздела
    protected function getPathString($subdivision){
        global $SUB_FOLDER;
        $path_arr = $this->getPathTree($subdivision);
        $path_string = $_SERVER['SERVER_NAME'].$SUB_FOLDER.'/';
        foreach($path_arr as $path_item){
            $path_string .= $path_item->EnglishName.'/';       
        }
        return $path_string;    
    }
    // получаем название поля (латинское) по ID
    function getFieldNameById($fieldID){
        global $nc_core;
        $sel_query = "SELECT `Field_Name` FROM `Field` WHERE Field_ID = ".$fieldID;
        return $nc_core->db->get_var($sel_query);        
    }
    // получаем объект поля по ID
    function getFieldById($fieldID){
        global $nc_core;
        $sel_query = "SELECT *,`Classificator_TypeOfData`.`TypeOfData_Name` 
        FROM `Field`
        JOIN `Classificator_TypeOfData` ON `Field`.`TypeOfData_ID` = `Classificator_TypeOfData`.`TypeOfData_ID`
        WHERE Field_ID = ".$fieldID;
        return $nc_core->db->get_row($sel_query);        
    }
    // получаем значение поля элемента по имени или id поля поля, с учетом типа поля 
    function getMessageField($message,$field){
        global $nc_core;
        $ret = '';
        if(is_numeric($field)){
            $field  = $this->getFieldById($field);
        }
        if(empty($message) || empty($field)){
            return '';
        }
        switch(true){
            case (/*$field->TypeOfData_ID == 4 && */$field->TypeOfData_Name == 'Список'):
                $_format = trim($field->Format).':';
                $table_name = substr($_format,0,strpos($_format,':'));
                $sel_query = "
                    SELECT 
                        `".$table_name."_Name`
                    FROM `Classificator_".$table_name."` WHERE ".$table_name."_ID = ".$message->{$field->Field_Name};
                $ret = $nc_core->db->get_var($sel_query);
            break;
            default:
                $ret = $message->{$field->Field_Name};
        }
        return preg_replace("/&#?[a-z0-9]{2,8};/i","",strip_tags($ret));
    }
    
}

// отдает набор опций для списка полей
function fieldOptions(array $fields,$default = null){
    $ret = '<option></option>';
    foreach($fields as $field){
        $ret .= '<option value="'.$field->Field_ID.'" '.($default && $default == $field->Field_ID ? 'selected="selected"':'').'>'.$field->Description.'</option>';
    }
    return $ret;    
}



?>